#!/usr/bin/env python

# auth-dialog
# format of print out: %key\n%value\n\n 
#

import sys

import gnomekeyring as gkey
import gtk

from syslogger import SysLogger

logger = SysLogger("OpenswanAuthDialog", 0)

KEYRING_UUID_TAG = "connection-uuid"
KEYRING_SN_TAG = "setting-name"
KEYRING_SK_TAG = "setting-key"

def lookup_secret(vpn_uuid, secret_name):
    attrs = { KEYRING_UUID_TAG : vpn_uuid,
              KEYRING_SN_TAG   : "vpn",
              KEYRING_SK_TAG   : secret_name }
    items = gkey.find_items_sync(gkey.ITEM_GENERIC_SECRET, attrs)
    if len(items) == 0:
        return None
    return items[0].secret

if __name__ == "__main__":
    logger.debug("Started with %s" % sys.argv)
    uuid = sys.argv[2]
    key = "password"
    try:
        print "%s\n%s\n\n" % (key, lookup_secret(uuid, key))
    except gkey.DeniedError:
        logger.error("Access denied")    
