import os

def address_to_long(address):
    _a = [0, 0, 0, 0]
    a = address.split('.', 4)
    if len(a) <> 4:
        raise ValueError("This is not valid ipv4-address")
    _a = map(int, a) # also raises ValueError
    for segment in _a:
        if not (0 <= segment <= 255):
            raise ValueError("This is not valid ipv4-address")
    return (_a[3] << 24) + (_a[2] << 16) + (_a[1] << 8) + (_a[0] << 0)
    
def long_to_address(la):
    a = [(la % 256), ((la % (1 << 16))) >> 8, ((la % (1 << 24))) >> 16, (la >> 24)]
    return ".".join(map(str, a))
    
def mask_long_to_short(mask):
    #@description: example: convert "255.255.255.0" to "24"
    try:
        la = address_to_long(mask)
    except ValueError:
        return mask
    nbit = 0
    i = 1 << 31
    while i > 0:
        if la & i:
            nbit += 1
        i = i >> 1
    return str(nbit)

def create_empty_file(path):
    head, tail = os.path.split(path)
    if not os.path.exists(head):
        os.makedirs(head, 0755)
    f = open(path, "w")
    f.close()
