import syslog

levelmes = ("info", "debug", "error")

class NullLogger(object):
    def __init__(self, owner, level):
        self.owner = owner
        self.level = level
    
    def info(self, message):
        self._log(0, message)
        
    def debug(self, message):
        self._log(1, message)
        
    def error(self, message):
        self._log(2, message)
    
    def _log(self, level, message):
        if(level >= self.level):
            self.log(level, message)
        
    def log(self, level, message):
        pass
        
class SysLogger(NullLogger):
    def log(self, level, message):
        global levelmes
        syslog.openlog(self.owner)
        syslog.syslog("<%s> %s" % (levelmes[level], message))
        syslog.closelog()
        
class StdoutLogger(NullLogger):
    def log(self, level, message):
        global levelmes
        print "%s: <%s> %s" % (self.owner, levelmes[level], message)
        
class MultiLogger(NullLogger):
    def __init__(self, owner, level):
        NullLogger.__init__(self, owner, level)
        self.syslogger = SysLogger(owner, level)
        self.stdoutlogger = StdoutLogger(owner, level)
        
    def log(self, level, message):
        self.syslogger.log(level, message)
        self.stdoutlogger.log(level, message)
        
